#include "validation.h"

// In this file, you should validate the grammar of your input files.
// Any additional constraints mentioned in the problem statement should also be checked here.

// Please use the Validator class from the header for verifying the grammar.
// This automatically exits with code 43 (WA) when input parsing fails,
// and exits with code 42 when reading input and all tests succeeded.
// Please use v.WA("some ", "error ", "here ") to exit with code 43 manually.

// When your program crashes unexpectedly, or something weird is going on,
// please write some info to stderr and return anything different from 42 and 43.

constexpr int maxn = 1e5;
int main(int argc, char **argv) {
	InputValidator v;
	int n = v.read_long_long(2, maxn);
	v.space();
	int a = v.read_long_long(0, n-1);
	v.space();
	int b = v.read_long_long(0, n-1);
	v.newline();

	v.assert(a != b, "a and b must be different, but are both ", a);

	for(int i = 0; i < n; ++i) {
		int l = v.read_long_long(0, n-1);
		v.space();
		int r = v.read_long_long(0, n-1);
		v.space();
		int t = v.read_long_long(0, 1);
		v.newline();
	}
}
